%define pam_redhat_version 0.99.10-1

%define _sbindir /sbin
%define _moduledir /%{_lib}/security
%define _secconfdir %{_sysconfdir}/security
%define _pamconfdir %{_sysconfdir}/pam.d

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	A security tool which provides authentication for applications.
Name:      	pam
Version:   	1.1.1
Release:   	2
Epoch:		1
Provides:	pam
License: 	GNU/GPL
URL:		http://www.us.kernel.org/pub/linux/libs/pam/index.html
Group:     	System/Base
Source0: 	http://ftp.us.kernel.org/pub/linux/libs/pam/library/Linux-PAM-%{version}.tar.bz2
Source2: 	https://fedorahosted.org/releases/p/a/pam-redhat/pam-redhat-%{pam_redhat_version}.tar.bz2
Source5: 	other.pamd
Source6: 	system-auth.pamd
Source7: 	password-auth.pamd
Source8: 	fingerprint-auth.pamd
Source9: 	smartcard-auth.pamd
Source10: 	config-util.pamd
Source11: 	dlopen.sh
Source12: 	system-auth.5
Source13: 	config-util.5
Source14: 	90-nproc.conf

Patch1:  	pam-1.0.90-redhat-modules.patch
Patch2:  	pam-1.0.91-std-noclose.patch
Patch3: 	pam-1.1.0-cracklib-authtok.patch
Patch4: 	pam-1.1.0-console-nochmod.patch
Patch5:  	pam-1.1.0-notally.patch
Patch6:  	pam-1.1.0-xauth-context.patch
Patch7:  	pam-1.1.0-console-fixes.patch

BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildArch:	i686
Requires:	cracklib cracklib-dicts >= 2.8 base-config >= 1.3.4-1 gnutls >= 1.3.1-4
Prereq: 	grep, mktemp, sed, /sbin/ldconfig
# libcap is a circular dependency - resolve by compiling
# libcap (w/o pam) - pam - libcap (w/ pam)
Prereq:		coreutils
BuildPrereq: 	autoconf bison flex sed cracklib db-devel
BuildPrereq: 	perl pkg-config cracklib-dicts
BuildRequires:	gnutls-devel >= 1.3.1-4
BuildRequires:  flex-devel

#Automatically resolved build dependencies
BuildRequires: cracklib-devel
BuildRequires: db-devel
BuildRequires: glibc-devel

%description
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication.

%package devel
Summary: 	pam development headers.
Group:     	%{group}
Requires: 	pam = %{epoch}:%{version}-%{release}

%description devel
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication. This package
contains header files and static libraries used for building both
PAM-aware applications and modules for use with PAM.

%post
/sbin/ldconfig
if [ ! -a /var/log/tallylog ] ; then
        install -m 600 /dev/null /var/log/tallylog
fi

%postun -p /sbin/ldconfig


%prep
%setup -q -n Linux-PAM-%{version} -a 2

# Add custom modules.
mv pam-redhat-%{pam_redhat_version}/* modules

%patch1 -p1 -b .redhat-modules
%patch2 -p1 -b .std-noclose
#%patch3 -p1 -b .authtok
%patch4 -p1 -b .nochmod
%patch5 -p1 -b .notally
#%patch6 -p1 -b .xauth-context
%patch7 -p1 -b .console-fixes

libtoolize -f
autoreconf

%build
%configure \
        --libdir=/%{_lib} \
        --includedir=%{_includedir}/security \
        --disable-prelude \
        --disable-selinux \
        --disable-audit \
        --enable-isadir=../..%{_moduledir} \
	--with-mailspool=/var/mail \
        --enable-read-both-confs \
        --sysconfdir=%_sysconfdir \
        --mandir=%_mandir
# we do not use _smp_mflags because the build of sources in yacc/flex fails
make

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p doc/txts
for readme in modules/pam_*/README ; do
        cp -f ${readme} doc/txts/README.`dirname ${readme} | sed -e 's|^modules/||'`
done

# Install the binaries, libraries, and modules.
make install DESTDIR=$RPM_BUILD_ROOT LDCONFIG=:

# RPM uses docs from source tree
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/Linux-PAM
# Included in setup package
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/environment

# Install default configuration files.
install -d -m 755 $RPM_BUILD_ROOT%{_pamconfdir}
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_pamconfdir}/other
install -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_pamconfdir}/system-auth
install -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_pamconfdir}/password-auth
install -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_pamconfdir}/fingerprint-auth
install -m 644 %{SOURCE9} $RPM_BUILD_ROOT%{_pamconfdir}/smartcard-auth
install -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{_pamconfdir}/config-util
install -m 644 %{SOURCE14} $RPM_BUILD_ROOT%{_secconfdir}/limits.d/90-nproc.conf
install -m 600 /dev/null $RPM_BUILD_ROOT%{_secconfdir}/opasswd
install -d -m 755 $RPM_BUILD_ROOT/var/log
install -m 600 /dev/null $RPM_BUILD_ROOT/var/log/tallylog

# Install man pages.
install -m 644 %{SOURCE12} %{SOURCE13} $RPM_BUILD_ROOT%{_mandir}/man5/

for phase in auth acct passwd session ; do
        ln -sf pam_unix.so $RPM_BUILD_ROOT%{_moduledir}/pam_unix_${phase}.so
done

# Remove .la files and make new .so links -- this depends on the value
# of _libdir not changing, and *not* being /usr/lib.
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
for lib in libpam libpamc libpam_misc ; do
pushd $RPM_BUILD_ROOT%{_libdir}
ln -sf ../../%{_lib}/${lib}.so.*.* ${lib}.so
popd
rm -f $RPM_BUILD_ROOT/%{_lib}/${lib}.so
rm -f $RPM_BUILD_ROOT/%{_lib}/${lib}.la
done
rm -f $RPM_BUILD_ROOT%{_moduledir}/*.la

# Duplicate doc file sets.
rm -fr $RPM_BUILD_ROOT/usr/share/doc/pam

# Create /lib/security in case it isn't the same as %{_moduledir}.
install -m755 -d $RPM_BUILD_ROOT/lib/security

%find_lang Linux-PAM

%check
# Make sure every module subdirectory gave us a module.  Yes, this is hackish.
for dir in modules/pam_* ; do
if [ -d ${dir} ] ; then
	[ ${dir} = "modules/pam_selinux" ] && continue
	[ ${dir} = "modules/pam_sepermit" ] && continue
	[ ${dir} = "modules/pam_tty_audit" ] && continue	
        [ ${dir} = "modules/pam_tally" ] && continue
        if ! ls -1 $RPM_BUILD_ROOT%{_moduledir}/`basename ${dir}`*.so ; then
                echo ERROR `basename ${dir}` did not build a module.
                exit 1
        fi
fi
done

# Check for module problems.  Specifically, check that every module we just
# installed can actually be loaded by a minimal PAM-aware application.
/sbin/ldconfig -n $RPM_BUILD_ROOT/%{_lib}
for module in $RPM_BUILD_ROOT%{_moduledir}/pam*.so ; do
        if ! env LD_LIBRARY_PATH=$RPM_BUILD_ROOT/%{_lib} \
                 %{SOURCE11} -ldl -lpam -L$RPM_BUILD_ROOT/%{_libdir} ${module} ; then
                echo ERROR module: ${module} cannot be loaded.
                exit 1
        fi
done

%files -f Linux-PAM.lang
%defattr(-,root,root)
%dir /etc/pam.d
%config(noreplace) /etc/pam.d/other
%config(noreplace) /etc/pam.d/system-auth
/%_lib/libpam.so.*
/%_lib/libpamc.so.*
/%_lib/libpam_misc.so.*
/sbin/mkhomedir_helper
/sbin/pam_console_apply
/sbin/pam_tally2
/sbin/unix_update
%attr(4755,root,root) /sbin/pam_timestamp_check
%attr(4755,root,root) /sbin/unix_chkpwd
%dir /%_lib/security
/%{_lib}/security/pam_access.so
/%{_lib}/security/pam_chroot.so
/%{_lib}/security/pam_console.so
/%{_lib}/security/pam_cracklib.so
/%{_lib}/security/pam_debug.so
/%{_lib}/security/pam_deny.so
/%{_lib}/security/pam_env.so
/%{_lib}/security/pam_filter.so
/%{_lib}/security/pam_ftp.so
/%{_lib}/security/pam_group.so
/%{_lib}/security/pam_issue.so
/%{_lib}/security/pam_lastlog.so
/%{_lib}/security/pam_limits.so
/%{_lib}/security/pam_listfile.so
/%{_lib}/security/pam_localuser.so
/%{_lib}/security/pam_loginuid.so
/%{_lib}/security/pam_mail.so
/%{_lib}/security/pam_mkhomedir.so
/%{_lib}/security/pam_motd.so
/%{_lib}/security/pam_nologin.so
/%{_lib}/security/pam_permit.so
/%{_lib}/security/pam_postgresok.so
/%{_lib}/security/pam_pwhistory.so
/%{_lib}/security/pam_rootok.so
/%{_lib}/security/pam_securetty.so
/%{_lib}/security/pam_shells.so
/%{_lib}/security/pam_stress.so
/%{_lib}/security/pam_succeed_if.so
/%{_lib}/security/pam_time.so
/%{_lib}/security/pam_timestamp.so
/%{_lib}/security/pam_unix.so
/%{_lib}/security/pam_unix_acct.so
/%{_lib}/security/pam_unix_auth.so
/%{_lib}/security/pam_unix_passwd.so
/%{_lib}/security/pam_unix_session.so
/%{_lib}/security/pam_userdb.so
/%{_lib}/security/pam_warn.so
/%{_lib}/security/pam_wheel.so
/%{_lib}/security/pam_xauth.so
/%{_lib}/security/pam_filter
/%{_lib}/security/pam_echo.so
/%{_lib}/security/pam_umask.so
/%{_lib}/security/pam_exec.so
/%{_lib}/security/pam_keyinit.so
/%{_lib}/security/pam_rhosts.so
/%{_lib}/security/pam_faildelay.so
/%{_lib}/security/pam_namespace.so
/%{_lib}/security/pam_tally2.so

%dir %_sysconfdir/security
%config(noreplace) %_sysconfdir/security/access.conf
%config(noreplace) %_sysconfdir/security/chroot.conf
%config(noreplace) %_sysconfdir/pam.d/config-util
%config %_sysconfdir/security/console.perms
%config(noreplace) %_sysconfdir/security/console.handlers
%config(noreplace) %_sysconfdir/pam.d/fingerprint-auth
%config(noreplace) %_sysconfdir/security/group.conf
%config(noreplace) %_sysconfdir/security/limits.conf
%config(noreplace) %_sysconfdir/security/pam_env.conf
%config(noreplace) %_sysconfdir/pam.d/password-auth
%config(noreplace) %_sysconfdir/pam.d/smartcard-auth
%config(noreplace) %_sysconfdir/security/time.conf
%config(noreplace) %_sysconfdir/security/opasswd
%config(noreplace) %_sysconfdir/security/namespace.conf
%config(noreplace) %_sysconfdir/security/namespace.init
%dir %_sysconfdir/security/limits.d
%config(noreplace) %_sysconfdir/security/limits.d/90-nproc.conf
%dir %_sysconfdir/security/console.apps
%dir %_sysconfdir/security/console.perms.d
%dir /var/run/console
%{_mandir}/man5/access.conf.5.gz
%{_mandir}/man5/config-util.5.gz
%{_mandir}/man5/console.apps.5.gz
%{_mandir}/man5/console.handlers.5.gz
%{_mandir}/man5/console.perms.5.gz
%{_mandir}/man5/group.conf.5.gz
%{_mandir}/man5/limits.conf.5.gz
%{_mandir}/man5/namespace.conf.5.gz
%{_mandir}/man5/pam.conf.5.gz
%{_mandir}/man5/pam.d.5.gz
%{_mandir}/man5/pam_env.conf.5.gz
%{_mandir}/man5/system-auth.5.gz
%{_mandir}/man5/time.conf.5.gz
%{_mandir}/man8/PAM.8.gz
%{_mandir}/man8/mkhomedir_helper.8.gz
%{_mandir}/man8/pam.8.gz
%{_mandir}/man8/pam_access.8.gz
%{_mandir}/man8/pam_console.8.gz
%{_mandir}/man8/pam_console_apply.8.gz
%{_mandir}/man8/pam_cracklib.8.gz
%{_mandir}/man8/pam_debug.8.gz
%{_mandir}/man8/pam_deny.8.gz
%{_mandir}/man8/pam_echo.8.gz
%{_mandir}/man8/pam_env.8.gz
%{_mandir}/man8/pam_exec.8.gz
%{_mandir}/man8/pam_faildelay.8.gz
%{_mandir}/man8/pam_filter.8.gz
%{_mandir}/man8/pam_ftp.8.gz
%{_mandir}/man8/pam_group.8.gz
%{_mandir}/man8/pam_issue.8.gz
%{_mandir}/man8/pam_keyinit.8.gz
%{_mandir}/man8/pam_lastlog.8.gz
%{_mandir}/man8/pam_limits.8.gz
%{_mandir}/man8/pam_listfile.8.gz
%{_mandir}/man8/pam_localuser.8.gz
%{_mandir}/man8/pam_loginuid.8.gz
%{_mandir}/man8/pam_mail.8.gz
%{_mandir}/man8/pam_mkhomedir.8.gz
%{_mandir}/man8/pam_motd.8.gz
%{_mandir}/man8/pam_namespace.8.gz
%{_mandir}/man8/pam_nologin.8.gz
%{_mandir}/man8/pam_permit.8.gz
%{_mandir}/man8/pam_postgresok.8.gz
%{_mandir}/man8/pam_pwhistory.8.gz
%{_mandir}/man8/pam_rhosts.8.gz
%{_mandir}/man8/pam_rootok.8.gz
%{_mandir}/man8/pam_securetty.8.gz
%{_mandir}/man8/pam_shells.8.gz
%{_mandir}/man8/pam_succeed_if.8.gz
%{_mandir}/man8/pam_tally2.8.gz
%{_mandir}/man8/pam_time.8.gz
%{_mandir}/man8/pam_timestamp.8.gz
%{_mandir}/man8/pam_timestamp_check.8.gz
%{_mandir}/man8/pam_tty_audit.8.gz
%{_mandir}/man8/pam_umask.8.gz
%{_mandir}/man8/pam_unix.8.gz
%{_mandir}/man8/pam_userdb.8.gz
%{_mandir}/man8/pam_warn.8.gz
%{_mandir}/man8/pam_wheel.8.gz
%{_mandir}/man8/pam_xauth.8.gz
%{_mandir}/man8/unix_chkpwd.8.gz
%{_mandir}/man8/unix_update.8.gz
/var/log/tallylog

%files devel
%defattr(-,root,root)
%_includedir/security/
%{_mandir}/man3/misc_conv.3.gz
%{_mandir}/man3/pam.3.gz
%{_mandir}/man3/pam_acct_mgmt.3.gz
%{_mandir}/man3/pam_authenticate.3.gz
%{_mandir}/man3/pam_chauthtok.3.gz
%{_mandir}/man3/pam_close_session.3.gz
%{_mandir}/man3/pam_conv.3.gz
%{_mandir}/man3/pam_end.3.gz
%{_mandir}/man3/pam_error.3.gz
%{_mandir}/man3/pam_fail_delay.3.gz
%{_mandir}/man3/pam_get_authtok.3.gz
%{_mandir}/man3/pam_get_authtok_noverify.3.gz
%{_mandir}/man3/pam_get_authtok_verify.3.gz
%{_mandir}/man3/pam_get_data.3.gz
%{_mandir}/man3/pam_get_item.3.gz
%{_mandir}/man3/pam_get_user.3.gz
%{_mandir}/man3/pam_getenv.3.gz
%{_mandir}/man3/pam_getenvlist.3.gz
%{_mandir}/man3/pam_info.3.gz
%{_mandir}/man3/pam_misc_drop_env.3.gz
%{_mandir}/man3/pam_misc_paste_env.3.gz
%{_mandir}/man3/pam_misc_setenv.3.gz
%{_mandir}/man3/pam_open_session.3.gz
%{_mandir}/man3/pam_prompt.3.gz
%{_mandir}/man3/pam_putenv.3.gz
%{_mandir}/man3/pam_set_data.3.gz
%{_mandir}/man3/pam_set_item.3.gz
%{_mandir}/man3/pam_setcred.3.gz
%{_mandir}/man3/pam_sm_acct_mgmt.3.gz
%{_mandir}/man3/pam_sm_authenticate.3.gz
%{_mandir}/man3/pam_sm_chauthtok.3.gz
%{_mandir}/man3/pam_sm_close_session.3.gz
%{_mandir}/man3/pam_sm_open_session.3.gz
%{_mandir}/man3/pam_sm_setcred.3.gz
%{_mandir}/man3/pam_start.3.gz
%{_mandir}/man3/pam_strerror.3.gz
%{_mandir}/man3/pam_syslog.3.gz
%{_mandir}/man3/pam_verror.3.gz
%{_mandir}/man3/pam_vinfo.3.gz
%{_mandir}/man3/pam_vprompt.3.gz
%{_mandir}/man3/pam_vsyslog.3.gz
%{_mandir}/man3/pam_xauth_data.3.gz
%_libdir/libpam.so
%_libdir/libpamc.so
%_libdir/libpam_misc.so

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sun Jan 03 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:1.1.1-2
- adjusted devel package dependency
* Sun Jan 03 2010 Karsten Brockmann <arcam@ccux-linux.de> 1:1.1.1-1
- Version update
* Mon May 12 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:1.1.0-1
- Version update
* Thu Jan 18 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:0.99.7.0-1
- Version update
* Sun Oct 08 2006 Karsten Brockmann <arcam@ccux-linux.de> 1:0.99.6.3-2
- edited pam_console rules to not interfere with udev
* Tue Oct 03 2006 Karsten Brockmann <arcam@ccux-linux.de> 1:0.99.6.3-1
- Version update
* Sun Feb 12 2006 Karsten Brockmann <arcam@ccux-linux.de> 1:0.99.3.0-2
- removed unneccessary symlink to gnutls, cleaned up specfile
- removed rogue libprelude dependency (fixes nasty login bug)
* Wed Jan 18 2006 Karsten Brockmann <arcam@ccux-linux.de> 1:0.99.3.0-1
- Version Update
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 1:0.99.2.1-4
- Minor fix in script
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 1:0.99.2.1-3
- Added sanity check
* Sun Jan 01 2006 Christian Metzen <metzench@ccux-linux.de> 1:0.99.2.1-2
- Added newest base-config as requirement
* Fri Dec 16 2005 Christian Metzen <metzench@ccux-linux.de> 1:0.99.2.1-1
- Version update
* Thu Dec 15 2005 Christian Metzen <metzench@ccux-linux.de> 1:0.81-4
- Added missing .so.0 symlinks
* Thu Dec 15 2005 Christian Metzen <metzench@ccux-linux.de> 1:0.81-3
- Version downgrade for now, readded pam-modules, corrected symlink bug in old 0.81 package
* Mon Dec 05 2005 Karsten Brockmann <arcam@ccux-linux.de> 0.99.2.0-1
- Version Update, temporarily removed additional RedHat pam-modules
* Sun Nov 06 2005 Christian Wasem <wasem@ccux-linux.de> 0.81-2
- moved sed replacements in libdir patch
* Sat Nov 05 2005 Karsten Brockmann <arcam@ccux-linux.de> 0.81-1
- Version Update
* Sat Aug 27 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-6
- Modified system-auth
* Sat Aug 27 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-5
- Added Modules again, added system-auth
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-4
- Modified other more strictly,some more sec modules
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-3
- Added PATH Config
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-2
- Cleaned out specfile
* Sun Aug 14 2005 Christian Metzen <metzench@ccux-linux.de> 0.80-1
- Initial Release
